VERSION 5.00
Begin VB.UserControl SysTray 
   ClientHeight    =   3600
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   4800
   InvisibleAtRuntime=   -1  'True
   Picture         =   "SysTray.ctx":0000
   ScaleHeight     =   3600
   ScaleWidth      =   4800
   ToolboxBitmap   =   "SysTray.ctx":27A2
   Begin VB.PictureBox hook 
      Height          =   735
      Left            =   2040
      ScaleHeight     =   675
      ScaleWidth      =   675
      TabIndex        =   0
      Top             =   120
      Visible         =   0   'False
      Width           =   735
   End
End
Attribute VB_Name = "SysTray"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'Default Property Values:
Const m_def_Enabled = False
Const m_def_hIcon = 0
Const m_def_Tip = ""
'Property Variables:
Dim m_Enabled As Boolean
Dim m_hIcon As Long
Dim m_Tip As String
'Event Declarations:
Event MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
Event LButtonDblClick(Button As Integer, Shift As Integer, X As Single, Y As Single)
Event LButtonDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
Event LButtonUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
Event RButtonDblClick(Button As Integer, Shift As Integer, X As Single, Y As Single)
Event RButtonDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
Event RButtonUp(Button As Integer, Shift As Integer, X As Single, Y As Single)

Private Type NOTIFYICONDATA
    cbSize As Long
    hWnd As Long
    uId As Long
    uFlags As Long
    ucallbackMessage As Long
    hIcon As Long
    szTip As String * 64
End Type

Private Const NIM_ADD = &H0
Private Const NIM_MODIFY = &H1
Private Const NIM_DELETE = &H2
Private Const WM_MOUSEMOVE = &H200
Private Const NIF_MESSAGE = &H1
Private Const NIF_ICON = &H2
Private Const NIF_TIP = &H4

Private Const WM_LBUTTONDBLCLK = &H203
Private Const WM_LBUTTONDOWN = &H201
Private Const WM_LBUTTONUP = &H202
Private Const WM_RBUTTONDBLCLK = &H206
Private Const WM_RBUTTONDOWN = &H204
Private Const WM_RBUTTONUP = &H205

Private Declare Function Shell_NotifyIcon Lib "shell32" Alias "Shell_NotifyIconA" (ByVal dwMessage As Long, pnid As NOTIFYICONDATA) As Boolean
Private t As NOTIFYICONDATA

Sub ModifyIcon()
t.cbSize = Len(t)
t.hWnd = hook.hWnd
t.uId = 1&
t.uFlags = NIF_ICON Or NIF_TIP Or NIF_MESSAGE
t.ucallbackMessage = WM_MOUSEMOVE
t.hIcon = m_hIcon
t.szTip = m_Tip & Chr$(0)
Shell_NotifyIcon NIM_MODIFY, t
End Sub

Private Sub RemoveIcon()
Shell_NotifyIcon NIM_DELETE, t
End Sub



Private Sub SetIcon()
t.cbSize = Len(t)
t.hWnd = hook.hWnd
t.uId = 1&
t.uFlags = NIF_ICON Or NIF_TIP Or NIF_MESSAGE
t.ucallbackMessage = WM_MOUSEMOVE
t.hIcon = m_hIcon
t.szTip = m_Tip & Chr$(0)
Shell_NotifyIcon NIM_ADD, t
End Sub

Private Sub hook_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
Static rec As Boolean, msg As Long
RaiseEvent MouseMove(Button, Shift, X, Y)
msg = X / Screen.TwipsPerPixelX
If rec = False Then
    rec = True
    Select Case msg
        Case WM_LBUTTONDBLCLK:
            RaiseEvent LButtonDblClick(Button, Shift, X, Y)
        Case WM_LBUTTONDOWN:
            RaiseEvent LButtonDown(Button, Shift, X, Y)
        Case WM_LBUTTONUP:
            RaiseEvent LButtonUp(Button, Shift, X, Y)
        Case WM_RBUTTONDBLCLK:
            RaiseEvent RButtonDblClick(Button, Shift, X, Y)
        Case WM_RBUTTONDOWN:
            RaiseEvent RButtonDown(Button, Shift, X, Y)
        Case WM_RBUTTONUP:
            RaiseEvent RButtonUp(Button, Shift, X, Y)
    End Select
    rec = False
End If
End Sub


Private Sub UserControl_Resize()
Width = ScaleX(Picture.Width, vbHimetric, vbTwips)
Height = ScaleY(Picture.Height, vbHimetric, vbTwips)
End Sub


Public Property Get Enabled() As Boolean
Attribute Enabled.VB_Description = "Returns/sets a value that determines whether an object can respond to user-generated events."
    Enabled = m_Enabled
End Property

Public Property Let Enabled(ByVal New_Enabled As Boolean)
    m_Enabled = New_Enabled
    PropertyChanged "Enabled"
    If m_Enabled = True Then
        SetIcon
    Else
        RemoveIcon
    End If
End Property

Public Property Get hIcon() As Variant
    hIcon = m_hIcon
End Property

Public Property Let hIcon(ByVal New_hIcon As Variant)
    m_hIcon = New_hIcon
    PropertyChanged "hIcon"
    If m_Enabled = True Then ModifyIcon
End Property

Public Property Get Tip() As Variant
    Tip = m_Tip
End Property

Public Property Let Tip(ByVal New_Tip As Variant)
    m_Tip = New_Tip
    PropertyChanged "Tip"
    If m_Enabled = True Then ModifyIcon
End Property

'Initialize Properties for User Control
Private Sub UserControl_InitProperties()
    m_Enabled = m_def_Enabled
    m_hIcon = m_def_hIcon
    m_Tip = m_def_Tip
End Sub

'Load property values from storage
Private Sub UserControl_ReadProperties(PropBag As PropertyBag)

    m_Enabled = PropBag.ReadProperty("Enabled", m_def_Enabled)
    m_hIcon = PropBag.ReadProperty("hIcon", m_def_hIcon)
    m_Tip = PropBag.ReadProperty("Tip", m_def_Tip)
End Sub

Private Sub UserControl_Terminate()
If m_Enabled = True Then RemoveIcon
End Sub

'Write property values to storage
Private Sub UserControl_WriteProperties(PropBag As PropertyBag)

    Call PropBag.WriteProperty("Enabled", m_Enabled, m_def_Enabled)
    Call PropBag.WriteProperty("Icon", m_hIcon, m_def_hIcon)
    Call PropBag.WriteProperty("Tip", m_Tip, m_def_Tip)
End Sub

